Index: /trunk/VUT/doc/SciReport/preprocessing.tex
===================================================================
--- /trunk/VUT/doc/SciReport/preprocessing.tex	(revision 272)
+++ /trunk/VUT/doc/SciReport/preprocessing.tex	(revision 287)
@@ -49,5 +49,5 @@
 \end{itemize}
 
-Both of these points are addressed bellow in more detail.
+Both of these points are addressed below in more detail.
 
 \subsection{From-object based visibility}
Index: /trunk/VUT/doc/SciReport/sampling.tex
===================================================================
--- /trunk/VUT/doc/SciReport/sampling.tex	(revision 283)
+++ /trunk/VUT/doc/SciReport/sampling.tex	(revision 287)
@@ -295,29 +295,10 @@
 
 
-\begin{table}
-\centering \footnotesize
-\begin{tabular}{|l|c|c|}
-  \hline\hline
-  View cells & Vienna selection & Vienna full \\\hline\hline
-  \#view cells & 105 & 16447 \\\hline\hline
-  \#input polygons & 525 & 82235 \\\hline\hline
-  BSP tree generation time & 0.016s & 10.328s \\\hline\hline
-  %%view cell insertion time & 0.016s & 7.984s \\\hline\hline
-  \#nodes & 1137 & 597933 \\\hline\hline
-  \#interior nodes & 568 & 298966\\\hline\hline
-  \#leaf nodes  & 569 & 298967\\\hline\hline
-  \#splits & 25 & 188936\\\hline\hline
-  max tree depth & 13 & 27\\\hline\hline
-  avg tree depth & 9.747 & 21.11\\\hline\hline
-  
- \end{tabular}
- \caption{Statistics for view cell BSP tree on the Vienna view cells and a selection of the Vienna view cells.}\label{tab:viewcell_bsp}
-\end{table}
-
 
 \begin{itemize}
 
-\item We use a number of input view cells given in advance. As input
-view cell  any closed mesh can be applied. The only requirement is
+\item A number of input view cells is given in advance, and we insert them into
+a BSP tree (i.e., we are changing their representation for a fast BSP tree lookup). As input
+view cell any closed mesh can be applied. The only requirement is
 that the any two view cells do not overlap.  The view cell
 polygons are extracted, storing a pointer to the parent view cell
@@ -330,7 +311,5 @@
 One input view cell can be associated with many leaves in case
 a view cell was split during the traversal. On the other hand, each leafs corresponds
-to exactly one or no view cell.  Some statistics about using this
-method on the Vienna view cells set are given in
-table~\ref{tab:viewcell_bsp}.
+to exactly one or no view cell.
 
 However, sometimes a good set of view
@@ -364,4 +343,28 @@
 resulting in a large PVS), the view cell is subdivided into smaller
 cells using some criteria.
+
+\begin{table}
+\centering \footnotesize
+\begin{tabular}{|l|c|c|c|}
+  \hline\hline
+  Input & Vienna view cells selection & Vienna view cells full & Vienna simple scene\\\hline\hline
+  method & insert input viewcells & insert input view cells & generate from scene polygons\\\hline\hline
+  \#view cells & 105 & 16447 & 4867\\\hline\hline
+  \#input polygons & 525 & 82235 & 16151\\\hline\hline
+  BSP tree generation time & 0.016s & 10.328s & 0.61s\\\hline\hline
+  %%view cell insertion time & 0.016s & 7.984s \\\hline\hline
+  \#nodes & 1137 & 597933 & 9733\\\hline\hline
+  \#interior nodes & 568 & 298966 & 4866\\\hline\hline
+  \#leaf nodes  & 569 & 298967& 4867\\\hline\hline
+  \#splits & 25 & 188936 & 2010\\\hline\hline
+  max tree depth & 13 & 27 & 17\\\hline\hline
+  avg tree depth & 9.747 & 21.11 & 12.48\\\hline\hline 
+ \end{tabular}
+ \caption{Statistics for the view cell BSP tree. In the first column we insert a selection of given view cells from the Vienna scene
+ into a BSP tree. In the second column we do the same for the full Vienna view cell set. In the third column we generate 
+ new view cells using a BSP tree subdivision of the Vienna simple scene. The termination criterium was to stop subdivision if there are  
+ 3 or less polygons per node.}\label{tab:viewcell_bsp}
+\end{table}
+
 
 In order to evaluate the best split plane, we first have to define the
@@ -385,4 +388,12 @@
 \end{itemize}
 
+
+
+Some statistics about the first two methods (i.e., the insertion of the view cells into the BSP tree, 
+and the automatic generation from the scene polygons using a BSP tree subdivision) is given in table~\ref{tab:viewcell_bsp}.
+We used a selection from given view cells for the Vienna scene for the first column,
+the full set for the second column, and the Vienna simple scene geometry for the
+automatic view cell generation. The measurements were conducted on a PC with 3.4GHz 
+P4 CPU.
 
 % In the future we aim to extend the view cell construction by using